/*
**	io.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>
#include <string.h>
#include <fcntl.h>
#include <setjmp.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

typedef unsigned char  Uc;
typedef unsigned short Us;
typedef unsigned int   Ui;
typedef unsigned long  Ul;

extern Window rt,w1;
extern Display *dpy;
extern GC gc,gc2;
extern Colormap map,dmap;
extern XColor c1;
extern XImage *xi;
extern XEvent pe;
extern XGCValues xgcv;
extern XSetWindowAttributes xswa;
extern XWindowAttributes xwa;
extern XFontStruct *font_info;
extern Visual  *vis;
static char *p;

int winw,winh;
int wx,wy;	/* window size */
int wix,wiy;	/* window image size */
int dx,dy,ddx,ddy,xys;
int fg_pix, bg_pix;
int dep;
int dstx=0,dsty=0,incx=0,incy=0;
int scr;
static int dh,dw;

Window rt,w1;
Display *dpy;
GC gc,gc2;
Colormap map,dmap;
XColor c1;
XImage *xi= NULL;
XEvent pe;
XGCValues xgcv;
XSetWindowAttributes xswa;
XWindowAttributes xwa;
XFontStruct *font_info;
Visual  *vis;

Visual *
FindFullColorVisual (dpy, scr, dep)
Display *dpy;
int *dep;
{
  XVisualInfo *vinfo_ret;
  XVisualInfo vinfo;
  int numitems, maxdep;
  
  vinfo.class = TrueColor;
  vinfo_ret = XGetVisualInfo(dpy, VisualClassMask, &vinfo, &numitems);
  if (numitems == 0) return NULL;

  maxdep = 0;
  while(numitems > 0) {
    if (vinfo_ret[numitems-1].depth > maxdep) {
      maxdep = vinfo_ret[numitems-1 ].depth;
    }
    numitems--;
  }
  XFree(vinfo_ret);
  if (maxdep < 0) return NULL;
  if (XMatchVisualInfo(dpy, scr, maxdep, TrueColor, &vinfo)) {
    *dep = maxdep;
    return vinfo.visual;
  }
  return NULL;
}

iwt(name, dhs, dvs)
char	*name;
	{
	int i,j;
	int x,y,u,v;

	XVisualInfo vinfo;

	ddx= dhs; ddy= dvs;
	dx= (ddx+15)&(~15);
	dy= (ddy+15)&(~15);
	xys= dx*dy;

		if( (dpy= XOpenDisplay("")) == NULL){
			fprintf(stderr,"Display open error.\n");
			exit(1);
			}
		scr=	DefaultScreen(dpy);
		dep=	DisplayPlanes(dpy,scr);
		rt=	RootWindow(dpy,scr);
		fg_pix= WhitePixel(dpy,scr);
		bg_pix= BlackPixel(dpy,scr);
		dh=	DisplayHeight(dpy,scr);
		dw=	DisplayWidth(dpy,scr);
		vis= FindFullColorVisual (dpy, scr, &dep);
		if(vis==NULL || dep<=8){
			if(XMatchVisualInfo(dpy,scr,8,PseudoColor,&vinfo)) {
				vis = vinfo.visual;
				}
			else {
			fprintf(stderr,"Requires 8 bit PseudoColor visual\n");
				exit(1);
				}
			}

	winw= wx=  dhs; winh= wy= dvs;
	xswa.event_mask = ExposureMask | StructureNotifyMask;
	xswa.background_pixel=	bg_pix;
	/*
	xswa.backing_store = NotUseful;
	*/
	xswa.backing_store = Always;

	w1=XCreateWindow(dpy,rt,0,0,wx,wy,1,dep,InputOutput,vis,
	(CWEventMask|CWBackPixel|CWBackingStore), &xswa);

	XChangeProperty(dpy, w1, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
			name, strlen(name));

	XSelectInput(dpy, w1, ButtonPressMask | ButtonReleaseMask 
		| PointerMotionMask | StructureNotifyMask);

	xgcv.foreground = fg_pix;
	xgcv.function = GXxor;
	xgcv.plane_mask = AllPlanes;
	xgcv.fill_style = FillSolid;
	xgcv.graphics_exposures = True;
	gc = XCreateGC(dpy, w1, GCForeground | GCFunction | GCPlaneMask |
				GCFillStyle | GCGraphicsExposures, &xgcv);

	XMapWindow(dpy, w1);
	    while(1){
		XNextEvent(dpy, &pe);
		if(pe.type == MapNotify && pe.xmap.event == w1)break;
		    }
	}
